package com.css.simulation.resource.common.domain.algorithm;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.constants.DictConstants;
import api.common.util.JsonUtil;
import com.css.simulation.resource.common.acl.entity.AlgorithmExpandAclEntity;
import com.css.simulation.resource.common.infrastructure.mysql.entity.AlgorithmExpandInfrastructureEntity;
import com.css.simulation.resource.common.infrastructure.mysql.mapper.AlgorithmExpandMapper;
import com.css.simulation.resource.common.infrastructure.mysql.param.AlgorithmExpandInfrastructureParam;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class AlgorithmExpandDomain {

    @Resource
    private AlgorithmExpandMapper algorithmExpandMapper;

    public void checkIsExisted(ResponseBodyVO<String> algorithmBody) {
        final String algorithmListResponseJson = algorithmBody.getInfo();
        final String algorithmListJson = JsonUtil.getString(algorithmListResponseJson, "data.content");
        final List<AlgorithmExpandAclEntity> algorithmExpandAclEntities = JsonUtil.jsonToList(algorithmListJson, AlgorithmExpandAclEntity.class);
        //1 获取算法平台查询到的所有算法ID
        final List<String> aclAlgorithmIds = algorithmExpandAclEntities.stream().map(AlgorithmExpandAclEntity::getAlgorithmId).collect(Collectors.toList());
        final List<String> infrastructureAlgorithmIds = algorithmExpandMapper.selectAlgorithmIds(AlgorithmExpandInfrastructureParam.builder().algorithmIds(aclAlgorithmIds).build());
        //2 不存在的数据插入数据库并设置状态为“未测试”
        algorithmExpandAclEntities.forEach(algorithmExpandAclEntity->{
            if(!infrastructureAlgorithmIds.contains(algorithmExpandAclEntity.getAlgorithmId())){
                final AlgorithmExpandInfrastructureEntity algorithmExpandInfrastructureEntity = new AlgorithmExpandInfrastructureEntity();
                BeanUtils.copyProperties(algorithmExpandAclEntity,algorithmExpandInfrastructureEntity);
                algorithmExpandInfrastructureEntity.setStatus(DictConstants.ALGORITHM_EXPAND_STATUS_NOT_TESTED);
                algorithmExpandMapper.insert(algorithmExpandInfrastructureEntity);
            }
        });
    }


}
