package com.css.simulation.resource.common.infrastructure.mysql.mapper;

import com.css.simulation.resource.common.infrastructure.mysql.entity.AlgorithmExpandInfrastructureEntity;
import com.css.simulation.resource.common.infrastructure.mysql.param.AlgorithmExpandInfrastructureParam;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface AlgorithmExpandMapper {

    @Select(" <script>" +
            " select id, algorithm_id, algorithm_name, description, algorithm_type, status\n" +
            " from algorithm_expand\n" +
            " where algorithm_id in\n" +
            "    <foreach item='item' collection='algorithmIds' separator=',' open='(' close=')'>\n" +
            "      #{item}\n" +
            "    </foreach>" +
            "</script>")
    List<AlgorithmExpandInfrastructureEntity> select(AlgorithmExpandInfrastructureParam algorithmExpandInfrastructureParam);

    @Select(" <script>" +
            " select  algorithm_id\n" +
            " from algorithm_expand\n" +
            " where algorithm_id in\n" +
            "    <foreach item='item' collection='algorithmIds' separator=',' open='(' close=')'>\n" +
            "      #{item}\n" +
            "    </foreach>" +
            "</script>")
    List<String> selectAlgorithmIds(AlgorithmExpandInfrastructureParam algorithmExpandInfrastructureParam);

    @Insert("insert into algorithm_expand(id, algorithm_id, algorithm_name, description, algorithm_type, status) \n" +
            "    value (#{id}, #{algorithmId}, #{algorithmName}, #{description}, #{algorithmType}, #{status})\n")
    void insert(AlgorithmExpandInfrastructureEntity algorithmExpandInfrastructureEntity);
}
